"""File generated by TLObjects' generator. All changes will be ERASED"""
from ...tl.tlobject import TLObject
from typing import Optional, List, Union, TYPE_CHECKING
import os
import struct


class GetDifferenceRequest(TLObject):
    CONSTRUCTOR_ID = 0xb2e4d7d
    SUBCLASS_OF_ID = 0x52662d55

    def __init__(self, from_version):
        """
        :param int from_version:

        :returns LangPackDifference: Instance of LangPackDifference.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.from_version = from_version  # type: int

    def to_dict(self):
        return {
            '_': 'GetDifferenceRequest',
            'from_version': self.from_version
        }

    def __bytes__(self):
        return b''.join((
            b'}M.\x0b',
            struct.pack('<i', self.from_version),
        ))

    @classmethod
    def from_reader(cls, reader):
        _from_version = reader.read_int()
        return cls(from_version=_from_version)


class GetLangPackRequest(TLObject):
    CONSTRUCTOR_ID = 0x9ab5c58e
    SUBCLASS_OF_ID = 0x52662d55

    def __init__(self, lang_code):
        """
        :param str lang_code:

        :returns LangPackDifference: Instance of LangPackDifference.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.lang_code = lang_code  # type: str

    def to_dict(self):
        return {
            '_': 'GetLangPackRequest',
            'lang_code': self.lang_code
        }

    def __bytes__(self):
        return b''.join((
            b'\x8e\xc5\xb5\x9a',
            TLObject.serialize_bytes(self.lang_code),
        ))

    @classmethod
    def from_reader(cls, reader):
        _lang_code = reader.tgread_string()
        return cls(lang_code=_lang_code)


class GetLanguagesRequest(TLObject):
    CONSTRUCTOR_ID = 0x800fd57d
    SUBCLASS_OF_ID = 0x280912c9

    def __init__(self):
        super().__init__()
        self.result = None
        self.content_related = True

    def to_dict(self):
        return {
            '_': 'GetLanguagesRequest'
        }

    def __bytes__(self):
        return b''.join((
            b'}\xd5\x0f\x80',
        ))

    @classmethod
    def from_reader(cls, reader):
        return cls()


class GetStringsRequest(TLObject):
    CONSTRUCTOR_ID = 0x2e1ee318
    SUBCLASS_OF_ID = 0xc7b7353d

    def __init__(self, lang_code, keys):
        """
        :param str lang_code:
        :param List[str] keys:

        :returns Vector<LangPackString>: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.lang_code = lang_code  # type: str
        self.keys = keys  # type: List[str]

    def to_dict(self):
        return {
            '_': 'GetStringsRequest',
            'lang_code': self.lang_code,
            'keys': [] if self.keys is None else self.keys[:]
        }

    def __bytes__(self):
        return b''.join((
            b'\x18\xe3\x1e.',
            TLObject.serialize_bytes(self.lang_code),
            b'\x15\xc4\xb5\x1c',struct.pack('<i', len(self.keys)),b''.join(TLObject.serialize_bytes(x) for x in self.keys),
        ))

    @classmethod
    def from_reader(cls, reader):
        _lang_code = reader.tgread_string()
        reader.read_int()
        _keys = []
        for _ in range(reader.read_int()):
            _x = reader.tgread_string()
            _keys.append(_x)

        return cls(lang_code=_lang_code, keys=_keys)

